struc WAVEHDR {
  .lpData	   dd ?
  .dwBufferLength  dd ?
  .dwBytesRecorded dd ?
  .dwUser	   dd ?
  .dwFlags	   dd ?
  .dwLoops	   dd ?
  .lpNext	   dd ?
  .Reserved	   dd ?
}
struct WAVEHDR

struc WAVEOUTCAPS {
  .wMid 	  dw ?
  .wPid 	  dw ?
  .vDriverVersion dd ?
  .szPname	  rb 20h
  .dwFormats	  dd ?
  .wChannels	  dw ?
  .wReserved1	  dw ?
  .dwSupport	  dd ?
}
struct WAVEOUTCAPS

struc WAVEINCAPS {
  .wMid 	  dw ?
  .wPid 	  dw ?
  .vDriverVersion dd ?
  .szPname	  rb 20h
  .dwFormats	  dd ?
  .wChannels	  dw ?
  .wReserved1	  dw ?
}
struct WAVEINCAPS

struc WAVEFORMAT {
  .wFormatTag	   dw ?
  .nChannels	   dw ?
  .nSamplesPerSec  dd ?
  .nAvgBytesPerSec dd ?
  .nBlockAlign	   dw ?
}
struct WAVEFORMAT

struc PCMWAVEFORMAT {
  .wf		  WAVEFORMAT
  .wBitsPerSample dw ?
}
struct PCMWAVEFORMAT

struc WAVEFORMATEX {
  .wFormatTag	   dw ?
  .nChannels	   dw ?
  .nSamplesPerSec  dd ?
  .nAvgBytesPerSec dd ?
  .nBlockAlign	   dw ?
  .wBitsPerSample  dw ?
  .cbSize	   dw ?
}
struct WAVEFORMATEX

WAVE_MAPPER = -1

CALLBACK_TYPEMASK    = 70000h
CALLBACK_NULL	     = 0h
CALLBACK_WINDOW      = 10000h
CALLBACK_TASK	     = 20000h
CALLBACK_FUNCTION    = 30000h
CALLBACK_THREAD      = CALLBACK_TASK
CALLBACK_EVENT	     = 50000h
CALLBACK_DISCONTINUE = 80000000h

MMSYSERR_BASE			     = 0
WAVERR_BASE			     = 32
MIDIERR_BASE			     = 64
TIMERR_BASE			     = 96
JOYERR_BASE			     = 160
MCIERR_BASE			     = 256
MIXERR_BASE				 = 1024
MCI_STRING_OFFSET		     = 512
MCI_VD_OFFSET			     = 1024
MCI_CD_OFFSET			     = 1088
MCI_WAVE_OFFSET 		     = 1152
MCI_SEQ_OFFSET			     = 1216


MAXERRORLENGTH			     = 128
TIME_MS 			     = 1h
TIME_SAMPLES			     = 2h
TIME_BYTES			     = 4h
TIME_SMPTE			     = 8h
TIME_MIDI			     = 10h
TIME_TICKS					 = 20h
MM_JOY1MOVE			     = 3A0h
MM_JOY2MOVE			     = 3A1h
MM_JOY1ZMOVE			     = 3A2h
MM_JOY2ZMOVE			     = 3A3h
MM_JOY1BUTTONDOWN		     = 3B5h
MM_JOY2BUTTONDOWN		     = 3B6h
MM_JOY1BUTTONUP 		     = 3B7h
MM_JOY2BUTTONUP 		     = 3B8h
MM_MCINOTIFY			     = 3B9h
MM_MCISYSTEM_STRING		     = 3CAh
MM_WOM_OPEN			     = 3BBh
MM_WOM_CLOSE			     = 3BCh
MM_WOM_DONE			     = 3BDh
MM_WIM_OPEN			     = 3BEh
MM_WIM_CLOSE			     = 3BFh
MM_WIM_DATA			     = 3C0h
MM_MIM_OPEN			     = 3C1h
MM_MIM_CLOSE			     = 3C2h
MM_MIM_DATA			     = 3C3h
MM_MIM_LONGDATA 		     = 3C4h
MM_MIM_ERROR			     = 3C5h
MM_MIM_LONGERROR		     = 3C6h
MM_MOM_OPEN			     = 3C7h
MM_MOM_CLOSE			     = 3C8h
MM_MOM_DONE			     = 3C9h
MMSYSERR_BASE			     = 0
WAVERR_BASE			     = 32
MIDIERR_BASE			     = 64
TIMERR_BASE			     = 96
JOYERR_BASE			     = 160
MCIERR_BASE			     = 256
MIXERR_BASE				 = 1024
MCI_STRING_OFFSET		     = 512
MCI_VD_OFFSET			     = 1024
MCI_CD_OFFSET			     = 1088
MCI_WAVE_OFFSET 		     = 1152
MCI_SEQ_OFFSET			     = 1216
MMSYSERR_NOERROR		     = 0
MMSYSERR_ERROR			     = MMSYSERR_BASE + 1
MMSYSERR_BADDEVICEID		     = MMSYSERR_BASE + 2
MMSYSERR_NOTENABLED		     = MMSYSERR_BASE + 3
MMSYSERR_ALLOCATED		     = MMSYSERR_BASE + 4
MMSYSERR_INVALHANDLE		     = MMSYSERR_BASE + 5
MMSYSERR_NODRIVER		     = MMSYSERR_BASE + 6
MMSYSERR_NOMEM			     = MMSYSERR_BASE + 7
MMSYSERR_NOTSUPPORTED		     = MMSYSERR_BASE + 8
MMSYSERR_BADERRNUM		     = MMSYSERR_BASE + 9
MMSYSERR_INVALFLAG		     = MMSYSERR_BASE + 10
MMSYSERR_INVALPARAM		     = MMSYSERR_BASE + 11
MMSYSERR_HANDLEBUSY		     = MMSYSERR_BASE + 12
MMSYSERR_INVALIDALIAS		     = MMSYSERR_BASE + 13
MMSYSERR_LASTERROR		     = MMSYSERR_BASE + 13
MM_MOM_POSITIONCB		     = 3CAh
MM_MCISIGNAL			     = 3CBh
MM_MIM_MOREDATA 		     = 3CCh
MIDICAPS_STREAM 		     = 8h
MEVT_F_SHORT			     = 0h
MEVT_F_LONG			     = 80000000h
MEVT_F_CALLBACK 		     = 40000000h
MIDISTRM_ERROR			     = -2
MIDIPROP_SET			     = 80000000h
MIDIPROP_GET			     = 40000000h
MIDIPROP_TIMEDIV		     = 1h
MIDIPROP_TEMPO			     = 2h
MIXER_SHORT_NAME_CHARS		     = 16
MIXER_LONG_NAME_CHARS		     = 64
MIXERR_INVALLINE		     = MIXERR_BASE + 0
MIXERR_INVALCONTROL		     = MIXERR_BASE + 1
MIXERR_INVALVALUE		     = MIXERR_BASE + 2
MIXERR_LASTERROR		     = MIXERR_BASE + 2
MIXER_OBJECTF_HANDLE		     = 80000000h
MIXER_OBJECTF_MIXER		     = 0h
MIXER_OBJECTF_HMIXER		     = MIXER_OBJECTF_HANDLE OR MIXER_OBJECTF_MIXER
MIXER_OBJECTF_WAVEOUT		     = 10000000h
MIXER_OBJECTF_HWAVEOUT		     = MIXER_OBJECTF_HANDLE OR MIXER_OBJECTF_WAVEOUT
MIXER_OBJECTF_WAVEIN		     = 20000000h
MIXER_OBJECTF_HWAVEIN		     = MIXER_OBJECTF_HANDLE OR MIXER_OBJECTF_WAVEIN
MIXER_OBJECTF_MIDIOUT		     = 30000000h
MIXER_OBJECTF_HMIDIOUT		     = MIXER_OBJECTF_HANDLE OR MIXER_OBJECTF_MIDIOUT
MIXER_OBJECTF_MIDIIN		     = 40000000h
MIXER_OBJECTF_HMIDIIN		     = MIXER_OBJECTF_HANDLE OR MIXER_OBJECTF_MIDIIN
MIXER_OBJECTF_AUX		     = 50000000h
MIXERLINE_LINEF_ACTIVE		     = 1h
MIXERLINE_LINEF_DISCONNECTED	     = 8000h
MIXERLINE_LINEF_SOURCE		     = 80000000h
MIXERLINE_COMPONENTTYPE_DST_FIRST    = 0h
MIXERLINE_COMPONENTTYPE_DST_UNDEFINED		     = MIXERLINE_COMPONENTTYPE_DST_FIRST + 0
MIXERLINE_COMPONENTTYPE_DST_DIGITAL  = MIXERLINE_COMPONENTTYPE_DST_FIRST + 1
MIXERLINE_COMPONENTTYPE_DST_LINE     = MIXERLINE_COMPONENTTYPE_DST_FIRST + 2
MIXERLINE_COMPONENTTYPE_DST_MONITOR  = MIXERLINE_COMPONENTTYPE_DST_FIRST + 3
MIXERLINE_COMPONENTTYPE_DST_SPEAKERS = MIXERLINE_COMPONENTTYPE_DST_FIRST + 4
MIXERLINE_COMPONENTTYPE_DST_HEADPHONES		     = MIXERLINE_COMPONENTTYPE_DST_FIRST + 5
MIXERLINE_COMPONENTTYPE_DST_TELEPHONE		     = MIXERLINE_COMPONENTTYPE_DST_FIRST + 6
MIXERLINE_COMPONENTTYPE_DST_WAVEIN   = MIXERLINE_COMPONENTTYPE_DST_FIRST + 7
MIXERLINE_COMPONENTTYPE_DST_VOICEIN  = MIXERLINE_COMPONENTTYPE_DST_FIRST + 8
MIXERLINE_COMPONENTTYPE_DST_LAST     = MIXERLINE_COMPONENTTYPE_DST_FIRST + 8
MIXERLINE_COMPONENTTYPE_SRC_FIRST    = 1000h
MIXERLINE_COMPONENTTYPE_SRC_UNDEFINED		     = MIXERLINE_COMPONENTTYPE_SRC_FIRST + 0
MIXERLINE_COMPONENTTYPE_SRC_DIGITAL  = MIXERLINE_COMPONENTTYPE_SRC_FIRST + 1
MIXERLINE_COMPONENTTYPE_SRC_LINE     = MIXERLINE_COMPONENTTYPE_SRC_FIRST + 2
MIXERLINE_COMPONENTTYPE_SRC_MICROPHONE		     = MIXERLINE_COMPONENTTYPE_SRC_FIRST + 3
MIXERLINE_COMPONENTTYPE_SRC_SYNTHESIZER 	     = MIXERLINE_COMPONENTTYPE_SRC_FIRST + 4
MIXERLINE_COMPONENTTYPE_SRC_COMPACTDISC 	     = MIXERLINE_COMPONENTTYPE_SRC_FIRST + 5
MIXERLINE_COMPONENTTYPE_SRC_TELEPHONE		     = MIXERLINE_COMPONENTTYPE_SRC_FIRST + 6
MIXERLINE_COMPONENTTYPE_SRC_PCSPEAKER		     = MIXERLINE_COMPONENTTYPE_SRC_FIRST + 7
MIXERLINE_COMPONENTTYPE_SRC_WAVEOUT  = MIXERLINE_COMPONENTTYPE_SRC_FIRST + 8
MIXERLINE_COMPONENTTYPE_SRC_AUXILIARY		     = MIXERLINE_COMPONENTTYPE_SRC_FIRST + 9
MIXERLINE_COMPONENTTYPE_SRC_ANALOG   = MIXERLINE_COMPONENTTYPE_SRC_FIRST + 10
MIXERLINE_COMPONENTTYPE_SRC_LAST     = MIXERLINE_COMPONENTTYPE_SRC_FIRST + 10
MIXERLINE_TARGETTYPE_UNDEFINED	     = 0
MIXERLINE_TARGETTYPE_WAVEOUT	     = 1
MIXERLINE_TARGETTYPE_WAVEIN	     = 2
MIXERLINE_TARGETTYPE_MIDIOUT	     = 3
MIXERLINE_TARGETTYPE_MIDIIN	     = 4
MIXERLINE_TARGETTYPE_AUX	     = 5
MIXER_GETLINEINFOF_DESTINATION	     = 0h
MIXER_GETLINEINFOF_SOURCE	     = 1h
MIXER_GETLINEINFOF_LINEID	     = 2h
MIXER_GETLINEINFOF_COMPONENTTYPE     = 3h
MIXER_GETLINEINFOF_TARGETTYPE	     = 4h
MIXER_GETLINEINFOF_QUERYMASK	     = 0Fh
MIXERCONTROL_CONTROLF_UNIFORM	     = 1h
MIXERCONTROL_CONTROLF_MULTIPLE	     = 2h
MIXERCONTROL_CONTROLF_DISABLED	     = 80000000h
MIXERCONTROL_CT_CLASS_MASK	     = 0F0000000h
MIXERCONTROL_CT_CLASS_CUSTOM	     = 0h
MIXERCONTROL_CT_CLASS_METER	     = 10000000h
MIXERCONTROL_CT_CLASS_SWITCH	     = 20000000h
MIXERCONTROL_CT_CLASS_NUMBER	     = 30000000h
MIXERCONTROL_CT_CLASS_SLIDER	     = 40000000h
MIXERCONTROL_CT_CLASS_FADER	     = 50000000h
MIXERCONTROL_CT_CLASS_TIME	     = 60000000h
MIXERCONTROL_CT_CLASS_LIST	     = 70000000h
MIXERCONTROL_CT_SUBCLASS_MASK	     = 0F000000h
MIXERCONTROL_CT_SC_SWITCH_BOOLEAN    = 0h
MIXERCONTROL_CT_SC_SWITCH_BUTTON     = 1000000h
MIXERCONTROL_CT_SC_METER_POLLED      = 0h
MIXERCONTROL_CT_SC_TIME_MICROSECS    = 0h
MIXERCONTROL_CT_SC_TIME_MILLISECS    = 1000000h
MIXERCONTROL_CT_SC_LIST_SINGLE	     = 0h
MIXERCONTROL_CT_SC_LIST_MULTIPLE     = 1000000h
MIXERCONTROL_CT_UNITS_MASK	     = 0FF0000h
MIXERCONTROL_CT_UNITS_CUSTOM	     = 0h
MIXERCONTROL_CT_UNITS_BOOLEAN	     = 10000h
MIXERCONTROL_CT_UNITS_SIGNED	     = 20000h
MIXERCONTROL_CT_UNITS_UNSIGNED	     = 30000h
MIXERCONTROL_CT_UNITS_DECIBELS	     = 40000h
MIXERCONTROL_CT_UNITS_PERCENT	     = 50000h
MIXERCONTROL_CONTROLTYPE_CUSTOM      = MIXERCONTROL_CT_CLASS_CUSTOM OR MIXERCONTROL_CT_UNITS_CUSTOM
MIXERCONTROL_CONTROLTYPE_BOOLEANMETER		     = MIXERCONTROL_CT_CLASS_METER OR MIXERCONTROL_CT_SC_METER_POLLED OR MIXERCONTROL_CT_UNITS_BOOLEAN
MIXERCONTROL_CONTROLTYPE_SIGNEDMETER = MIXERCONTROL_CT_CLASS_METER OR MIXERCONTROL_CT_SC_METER_POLLED OR MIXERCONTROL_CT_UNITS_SIGNED
MIXERCONTROL_CONTROLTYPE_PEAKMETER   = MIXERCONTROL_CONTROLTYPE_SIGNEDMETER + 1
MIXERCONTROL_CONTROLTYPE_UNSIGNEDMETER		     = MIXERCONTROL_CT_CLASS_METER OR MIXERCONTROL_CT_SC_METER_POLLED OR MIXERCONTROL_CT_UNITS_UNSIGNED
MIXERCONTROL_CONTROLTYPE_BOOLEAN     = MIXERCONTROL_CT_CLASS_SWITCH OR MIXERCONTROL_CT_SC_SWITCH_BOOLEAN OR MIXERCONTROL_CT_UNITS_BOOLEAN
MIXERCONTROL_CONTROLTYPE_ONOFF	     = MIXERCONTROL_CONTROLTYPE_BOOLEAN + 1
MIXERCONTROL_CONTROLTYPE_MUTE	     = MIXERCONTROL_CONTROLTYPE_BOOLEAN + 2
MIXERCONTROL_CONTROLTYPE_MONO	     = MIXERCONTROL_CONTROLTYPE_BOOLEAN + 3
MIXERCONTROL_CONTROLTYPE_LOUDNESS    = MIXERCONTROL_CONTROLTYPE_BOOLEAN + 4
MIXERCONTROL_CONTROLTYPE_STEREOENH   = MIXERCONTROL_CONTROLTYPE_BOOLEAN + 5
MIXERCONTROL_CONTROLTYPE_BUTTON      = MIXERCONTROL_CT_CLASS_SWITCH OR MIXERCONTROL_CT_SC_SWITCH_BUTTON OR MIXERCONTROL_CT_UNITS_BOOLEAN
MIXERCONTROL_CONTROLTYPE_DECIBELS    = MIXERCONTROL_CT_CLASS_NUMBER OR MIXERCONTROL_CT_UNITS_DECIBELS
MIXERCONTROL_CONTROLTYPE_SIGNED      = MIXERCONTROL_CT_CLASS_NUMBER OR MIXERCONTROL_CT_UNITS_SIGNED
MIXERCONTROL_CONTROLTYPE_UNSIGNED    = MIXERCONTROL_CT_CLASS_NUMBER OR MIXERCONTROL_CT_UNITS_UNSIGNED
MIXERCONTROL_CONTROLTYPE_PERCENT     = MIXERCONTROL_CT_CLASS_NUMBER OR MIXERCONTROL_CT_UNITS_PERCENT
MIXERCONTROL_CONTROLTYPE_SLIDER      = MIXERCONTROL_CT_CLASS_SLIDER OR MIXERCONTROL_CT_UNITS_SIGNED
MIXERCONTROL_CONTROLTYPE_PAN	     = MIXERCONTROL_CONTROLTYPE_SLIDER + 1
MIXERCONTROL_CONTROLTYPE_QSOUNDPAN   = MIXERCONTROL_CONTROLTYPE_SLIDER + 2
MIXERCONTROL_CONTROLTYPE_FADER	     = MIXERCONTROL_CT_CLASS_FADER OR MIXERCONTROL_CT_UNITS_UNSIGNED
MIXERCONTROL_CONTROLTYPE_VOLUME      = MIXERCONTROL_CONTROLTYPE_FADER + 1
MIXERCONTROL_CONTROLTYPE_BASS	     = MIXERCONTROL_CONTROLTYPE_FADER + 2
MIXERCONTROL_CONTROLTYPE_TREBLE      = MIXERCONTROL_CONTROLTYPE_FADER + 3
MIXERCONTROL_CONTROLTYPE_EQUALIZER   = MIXERCONTROL_CONTROLTYPE_FADER + 4
MIXERCONTROL_CONTROLTYPE_SINGLESELECT		     = MIXERCONTROL_CT_CLASS_LIST OR MIXERCONTROL_CT_SC_LIST_SINGLE OR MIXERCONTROL_CT_UNITS_BOOLEAN
MIXERCONTROL_CONTROLTYPE_MUX	     = MIXERCONTROL_CONTROLTYPE_SINGLESELECT + 1
MIXERCONTROL_CONTROLTYPE_MULTIPLESELECT 	     = MIXERCONTROL_CT_CLASS_LIST OR MIXERCONTROL_CT_SC_LIST_MULTIPLE OR MIXERCONTROL_CT_UNITS_BOOLEAN
MIXERCONTROL_CONTROLTYPE_MIXER	     = MIXERCONTROL_CONTROLTYPE_MULTIPLESELECT + 1
MIXERCONTROL_CONTROLTYPE_MICROTIME   = MIXERCONTROL_CT_CLASS_TIME OR MIXERCONTROL_CT_SC_TIME_MICROSECS OR MIXERCONTROL_CT_UNITS_UNSIGNED
MIXERCONTROL_CONTROLTYPE_MILLITIME   = MIXERCONTROL_CT_CLASS_TIME OR MIXERCONTROL_CT_SC_TIME_MILLISECS OR MIXERCONTROL_CT_UNITS_UNSIGNED
MIXER_GETLINECONTROLSF_ALL	     = 0h
MIXER_GETLINECONTROLSF_ONEBYID	     = 1h
MIXER_GETLINECONTROLSF_ONEBYTYPE     = 2h
MIXER_GETLINECONTROLSF_QUERYMASK     = 0Fh
MIXER_GETCONTROLDETAILSF_VALUE	     = 0h
MIXER_GETCONTROLDETAILSF_LISTTEXT    = 1h
MIXER_GETCONTROLDETAILSF_QUERYMASK   = 0Fh
MIXER_SETCONTROLDETAILSF_VALUE	     = 0h
MIXER_SETCONTROLDETAILSF_CUSTOM      = 1h
MIXER_SETCONTROLDETAILSF_QUERYMASK   = 0Fh
JOY_BUTTON5			     = 10h
JOY_BUTTON6			     = 20h
JOY_BUTTON7			     = 40h
JOY_BUTTON8			     = 80h
JOY_BUTTON9			     = 100h
JOY_BUTTON10			     = 200h
JOY_BUTTON11			     = 400h
JOY_BUTTON12			     = 800h
JOY_BUTTON13			     = 1000h
JOY_BUTTON14			     = 2000h
JOY_BUTTON15			     = 4000h
JOY_BUTTON16			     = 8000h
JOY_BUTTON17			     = 10000h
JOY_BUTTON18			     = 20000h
JOY_BUTTON19			     = 40000h
JOY_BUTTON20			     = 80000h
JOY_BUTTON21			     = 100000h
JOY_BUTTON22			     = 200000h
JOY_BUTTON23			     = 400000h
JOY_BUTTON24			     = 800000h
JOY_BUTTON25			     = 1000000h
JOY_BUTTON26			     = 2000000h
JOY_BUTTON27			     = 4000000h
JOY_BUTTON28			     = 8000000h
JOY_BUTTON29			     = 10000000h
JOY_BUTTON30			     = 20000000h
JOY_BUTTON31			     = 40000000h
JOY_BUTTON32			     = 80000000h
JOY_POVCENTERED 		     = -1
JOY_POVFORWARD			     = 0
JOY_POVRIGHT			     = 9000
JOY_POVBACKWARD 		     = 18000
JOY_POVLEFT			     = 27000
JOY_RETURNX			     = 1h
JOY_RETURNY			     = 2h
JOY_RETURNZ			     = 4h
JOY_RETURNR			     = 8h
JOY_RETURNU			     = 10h
JOY_RETURNV			     = 20h
JOY_RETURNPOV			     = 40h
JOY_RETURNBUTTONS		     = 80h
JOY_RETURNRAWDATA		     = 100h
JOY_RETURNPOVCTS		     = 200h
JOY_RETURNCENTERED		     = 400h
JOY_USEDEADZONE 		     = 800h
JOY_RETURNALL			     = JOY_RETURNX OR JOY_RETURNY OR JOY_RETURNZ OR JOY_RETURNR OR JOY_RETURNU OR JOY_RETURNV OR JOY_RETURNPOV OR JOY_RETURNBUTTONS
JOY_CAL_READALWAYS		     = 10000h
JOY_CAL_READXYONLY		     = 20000h
JOY_CAL_READ3			     = 40000h
JOY_CAL_READ4			     = 80000h
JOY_CAL_READXONLY		     = 100000h
JOY_CAL_READYONLY		     = 200000h
JOY_CAL_READ5			     = 400000h
JOY_CAL_READ6			     = 800000h
JOY_CAL_READZONLY		     = 1000000h
JOY_CAL_READRONLY		     = 2000000h
JOY_CAL_READUONLY		     = 4000000h
JOY_CAL_READVONLY		     = 8000000h
WAVE_FORMAT_QUERY		     = 1h
SND_PURGE			     = 40h
SND_APPLICATION 		     = 80h
WAVE_MAPPED			     = 4h
WAVE_FORMAT_DIRECT		     = 8h
WAVE_FORMAT_DIRECT_QUERY	     = WAVE_FORMAT_QUERY OR WAVE_FORMAT_DIRECT
MIM_MOREDATA			     = MM_MIM_MOREDATA
MOM_POSITIONCB			     = MM_MOM_POSITIONCB
MIDI_IO_STATUS			     = 20h
DRV_LOAD			     = 1h
DRV_ENABLE			     = 2h
DRV_OPEN			     = 3h
DRV_CLOSE			     = 4h
DRV_DISABLE			     = 5h
DRV_FREE			     = 6h
DRV_CONFIGURE			     = 7h
DRV_QUERYCONFIGURE		     = 8h
DRV_INSTALL			     = 9h
DRV_REMOVE			     = 0Ah
DRV_EXITSESSION 		     = 0Bh
DRV_POWER			     = 0Fh
DRV_RESERVED			     = 800h
DRV_USER			     = 4000h
DRVCNF_CANCEL			     = 0h
DRVCNF_OK			     = 1h
DRVCNF_RESTART			     = 2h
DRV_CANCEL			     = DRVCNF_CANCEL
DRV_OK				     = DRVCNF_OK
DRV_RESTART			     = DRVCNF_RESTART
DRV_MCI_FIRST			     = DRV_RESERVED
DRV_MCI_LAST			     = DRV_RESERVED + 0FFFh



MMSYSERR_NOERROR		     = 0
MMSYSERR_ERROR			     = MMSYSERR_BASE + 1
MMSYSERR_BADDEVICEID		     = MMSYSERR_BASE + 2
MMSYSERR_NOTENABLED		     = MMSYSERR_BASE + 3
MMSYSERR_ALLOCATED		     = MMSYSERR_BASE + 4
MMSYSERR_INVALHANDLE		     = MMSYSERR_BASE + 5
MMSYSERR_NODRIVER		     = MMSYSERR_BASE + 6
MMSYSERR_NOMEM			     = MMSYSERR_BASE + 7
MMSYSERR_NOTSUPPORTED		     = MMSYSERR_BASE + 8
MMSYSERR_BADERRNUM		     = MMSYSERR_BASE + 9
MMSYSERR_INVALFLAG		     = MMSYSERR_BASE + 10
MMSYSERR_INVALPARAM		     = MMSYSERR_BASE + 11
MMSYSERR_HANDLEBUSY		     = MMSYSERR_BASE + 12
MMSYSERR_INVALIDALIAS		     = MMSYSERR_BASE + 13
MMSYSERR_LASTERROR		     = MMSYSERR_BASE + 13

MMIOERR_BASE			     = 256
MMIOERR_FILENOTFOUND		     = MMIOERR_BASE + 1
MMIOERR_OUTOFMEMORY		     = MMIOERR_BASE + 2
MMIOERR_CANNOTOPEN		     = MMIOERR_BASE + 3
MMIOERR_CANNOTCLOSE		     = MMIOERR_BASE + 4
MMIOERR_CANNOTREAD		     = MMIOERR_BASE + 5
MMIOERR_CANNOTWRITE		     = MMIOERR_BASE + 6
MMIOERR_CANNOTSEEK		     = MMIOERR_BASE + 7
MMIOERR_CANNOTEXPAND		     = MMIOERR_BASE + 8
MMIOERR_CHUNKNOTFOUND		     = MMIOERR_BASE + 9
MMIOERR_UNBUFFERED		     = MMIOERR_BASE + 10
MMIO_RWMODE			     = 3h
MMIO_SHAREMODE			     = 70h
MMIO_CREATE			     = 1000h
MMIO_PARSE			     = 100h
MMIO_DELETE			     = 200h
MMIO_EXIST			     = 4000h
MMIO_ALLOCBUF			     = 10000h
MMIO_GETTEMP			     = 20000h
MMIO_DIRTY			     = 10000000h
MMIO_OPEN_VALID 		     = 3FFFFh
MMIO_READ			     = 0h
MMIO_WRITE			     = 1h
MMIO_READWRITE			     = 2h
MMIO_COMPAT			     = 0h
MMIO_EXCLUSIVE			     = 10h
MMIO_DENYWRITE			     = 20h
MMIO_DENYREAD			     = 30h
MMIO_DENYNONE			     = 40h
MMIO_FHOPEN			     = 10h
MMIO_EMPTYBUF			     = 10h
MMIO_TOUPPER			     = 10h
MMIO_INSTALLPROC		     = 10000h
MMIO_GLOBALPROC 		     = 10000000h
MMIO_UNICODEPROC		     = 1000000h
MMIO_REMOVEPROC 		     = 20000h
MMIO_FINDPROC			     = 40000h
MMIO_FINDCHUNK			     = 10h
MMIO_FINDRIFF			     = 20h
MMIO_FINDLIST			     = 40h
MMIO_CREATERIFF 		     = 20h
MMIO_CREATELIST 		     = 40h
MMIO_VALIDPROC			     = 11070000h
MMIOM_READ			     = MMIO_READ
MMIOM_WRITE			     = MMIO_WRITE
MMIOM_SEEK			     = 2
MMIOM_OPEN			     = 3
MMIOM_CLOSE			     = 4
MMIOM_WRITEFLUSH		     = 5
MMIOM_RENAME			     = 6
MMIOM_USER			     = 8000h
SEEK_SET			     = 0
SEEK_CUR			     = 1
SEEK_END			     = 2
MMIO_DEFAULTBUFFER		     = 8192
MCIERR_INVALID_DEVICE_ID	     = MCIERR_BASE + 1
MCIERR_UNRECOGNIZED_KEYWORD	     = MCIERR_BASE + 3
MCIERR_UNRECOGNIZED_COMMAND	     = MCIERR_BASE + 5
MCIERR_HARDWARE 		     = MCIERR_BASE + 6
MCIERR_INVALID_DEVICE_NAME	     = MCIERR_BASE + 7
MCIERR_OUT_OF_MEMORY		     = MCIERR_BASE + 8
MCIERR_DEVICE_OPEN		     = MCIERR_BASE + 9
MCIERR_CANNOT_LOAD_DRIVER	     = MCIERR_BASE + 10
MCIERR_MISSING_COMMAND_STRING	     = MCIERR_BASE + 11
MCIERR_PARAM_OVERFLOW		     = MCIERR_BASE + 12
MCIERR_MISSING_STRING_ARGUMENT	     = MCIERR_BASE + 13
MCIERR_BAD_INTEGER		     = MCIERR_BASE + 14
MCIERR_PARSER_INTERNAL		     = MCIERR_BASE + 15
MCIERR_DRIVER_INTERNAL		     = MCIERR_BASE + 16
MCIERR_MISSING_PARAMETER	     = MCIERR_BASE + 17
MCIERR_UNSUPPORTED_FUNCTION	     = MCIERR_BASE + 18
MCIERR_FILE_NOT_FOUND		     = MCIERR_BASE + 19
MCIERR_DEVICE_NOT_READY 	     = MCIERR_BASE + 20
MCIERR_INTERNAL 		     = MCIERR_BASE + 21
MCIERR_DRIVER			     = MCIERR_BASE + 22
MCIERR_CANNOT_USE_ALL		     = MCIERR_BASE + 23
MCIERR_MULTIPLE 		     = MCIERR_BASE + 24
MCIERR_EXTENSION_NOT_FOUND	     = MCIERR_BASE + 25
MCIERR_OUTOFRANGE		     = MCIERR_BASE + 26
MCIERR_FLAGS_NOT_COMPATIBLE	     = MCIERR_BASE + 28
MCIERR_FILE_NOT_SAVED		     = MCIERR_BASE + 30
MCIERR_DEVICE_TYPE_REQUIRED	     = MCIERR_BASE + 31
MCIERR_DEVICE_LOCKED		     = MCIERR_BASE + 32
MCIERR_DUPLICATE_ALIAS		     = MCIERR_BASE + 33
MCIERR_BAD_CONSTANT		     = MCIERR_BASE + 34
MCIERR_MUST_USE_SHAREABLE	     = MCIERR_BASE + 35
MCIERR_MISSING_DEVICE_NAME	     = MCIERR_BASE + 36
MCIERR_BAD_TIME_FORMAT		     = MCIERR_BASE + 37
MCIERR_NO_CLOSING_QUOTE 	     = MCIERR_BASE + 38
MCIERR_DUPLICATE_FLAGS		     = MCIERR_BASE + 39
MCIERR_INVALID_FILE		     = MCIERR_BASE + 40
MCIERR_NULL_PARAMETER_BLOCK	     = MCIERR_BASE + 41
MCIERR_UNNAMED_RESOURCE 	     = MCIERR_BASE + 42
MCIERR_NEW_REQUIRES_ALIAS	     = MCIERR_BASE + 43
MCIERR_NOTIFY_ON_AUTO_OPEN	     = MCIERR_BASE + 44
MCIERR_NO_ELEMENT_ALLOWED	     = MCIERR_BASE + 45
MCIERR_NONAPPLICABLE_FUNCTION	     = MCIERR_BASE + 46
MCIERR_ILLEGAL_FOR_AUTO_OPEN	     = MCIERR_BASE + 47
MCIERR_FILENAME_REQUIRED	     = MCIERR_BASE + 48
MCIERR_EXTRA_CHARACTERS 	     = MCIERR_BASE + 49
MCIERR_DEVICE_NOT_INSTALLED	     = MCIERR_BASE + 50
MCIERR_GET_CD			     = MCIERR_BASE + 51
MCIERR_SET_CD			     = MCIERR_BASE + 52
MCIERR_SET_DRIVE		     = MCIERR_BASE + 53
MCIERR_DEVICE_LENGTH		     = MCIERR_BASE + 54
MCIERR_DEVICE_ORD_LENGTH	     = MCIERR_BASE + 55
MCIERR_NO_INTEGER		     = MCIERR_BASE + 56
MCIERR_WAVE_OUTPUTSINUSE	     = MCIERR_BASE + 64
MCIERR_WAVE_SETOUTPUTINUSE	     = MCIERR_BASE + 65
MCIERR_WAVE_INPUTSINUSE 	     = MCIERR_BASE + 66
MCIERR_WAVE_SETINPUTINUSE	     = MCIERR_BASE + 67
MCIERR_WAVE_OUTPUTUNSPECIFIED	     = MCIERR_BASE + 68
MCIERR_WAVE_INPUTUNSPECIFIED	     = MCIERR_BASE + 69
MCIERR_WAVE_OUTPUTSUNSUITABLE	     = MCIERR_BASE + 70
MCIERR_WAVE_SETOUTPUTUNSUITABLE      = MCIERR_BASE + 71
MCIERR_WAVE_INPUTSUNSUITABLE	     = MCIERR_BASE + 72
MCIERR_WAVE_SETINPUTUNSUITABLE	     = MCIERR_BASE + 73
MCIERR_SEQ_DIV_INCOMPATIBLE	     = MCIERR_BASE + 80
MCIERR_SEQ_PORT_INUSE		     = MCIERR_BASE + 81
MCIERR_SEQ_PORT_NONEXISTENT	     = MCIERR_BASE + 82
MCIERR_SEQ_PORT_MAPNODEVICE	     = MCIERR_BASE + 83
MCIERR_SEQ_PORT_MISCERROR	     = MCIERR_BASE + 84
MCIERR_SEQ_TIMER		     = MCIERR_BASE + 85
MCIERR_SEQ_PORTUNSPECIFIED	     = MCIERR_BASE + 86
MCIERR_SEQ_NOMIDIPRESENT	     = MCIERR_BASE + 87
MCIERR_NO_WINDOW		     = MCIERR_BASE + 90
MCIERR_CREATEWINDOW		     = MCIERR_BASE + 91
MCIERR_FILE_READ		     = MCIERR_BASE + 92
MCIERR_FILE_WRITE		     = MCIERR_BASE + 93
MCIERR_CUSTOM_DRIVER_BASE	     = MCIERR_BASE + 256
MCI_FIRST			     = 800h
MCI_OPEN			     = 803h
MCI_CLOSE			     = 804h
MCI_ESCAPE			     = 805h
MCI_PLAY			     = 806h
MCI_SEEK			     = 807h
MCI_STOP			     = 808h
MCI_PAUSE			     = 809h
MCI_INFO			     = 80Ah
MCI_GETDEVCAPS			     = 80Bh
MCI_SPIN			     = 80Ch
MCI_SET 			     = 80Dh
MCI_STEP			     = 80Eh
MCI_RECORD			     = 80Fh
MCI_SYSINFO			     = 810h
MCI_BREAK			     = 811h
MCI_SOUND			     = 812h
MCI_SAVE			     = 813h
MCI_STATUS			     = 814h
MCI_CUE 			     = 830h
MCI_REALIZE			     = 840h
MCI_WINDOW			     = 841h
MCI_PUT 			     = 842h
MCI_WHERE			     = 843h
MCI_FREEZE			     = 844h
MCI_UNFREEZE			     = 845h
MCI_LOAD			     = 850h
MCI_CUT 			     = 851h
MCI_COPY			     = 852h
MCI_PASTE			     = 853h
MCI_UPDATE			     = 854h
MCI_RESUME			     = 855h
MCI_DELETE			     = 856h
MCI_LAST			     = 0FFFh
MCI_USER_MESSAGES		     = 400h + MCI_FIRST
MCI_ALL_DEVICE_ID		     = -1
MCI_DEVTYPE_VCR 		     = 513
MCI_DEVTYPE_VIDEODISC		     = 514
MCI_DEVTYPE_OVERLAY		     = 515
MCI_DEVTYPE_CD_AUDIO		     = 516
MCI_DEVTYPE_DAT 		     = 517
MCI_DEVTYPE_SCANNER		     = 518
MCI_DEVTYPE_ANIMATION		     = 519
MCI_DEVTYPE_DIGITAL_VIDEO	     = 520
MCI_DEVTYPE_OTHER		     = 521
MCI_DEVTYPE_WAVEFORM_AUDIO	     = 522
MCI_DEVTYPE_SEQUENCER		     = 523
MCI_DEVTYPE_FIRST		     = MCI_DEVTYPE_VCR
MCI_DEVTYPE_LAST		     = MCI_DEVTYPE_SEQUENCER
MCI_DEVTYPE_FIRST_USER		     = 1000h
MCI_MODE_NOT_READY		     = MCI_STRING_OFFSET + 12
MCI_MODE_STOP			     = MCI_STRING_OFFSET + 13
MCI_MODE_PLAY			     = MCI_STRING_OFFSET + 14
MCI_MODE_RECORD 		     = MCI_STRING_OFFSET + 15
MCI_MODE_SEEK			     = MCI_STRING_OFFSET + 16
MCI_MODE_PAUSE			     = MCI_STRING_OFFSET + 17
MCI_MODE_OPEN			     = MCI_STRING_OFFSET + 18
MCI_FORMAT_MILLISECONDS 	     = 0
MCI_FORMAT_HMS			     = 1
MCI_FORMAT_MSF			     = 2
MCI_FORMAT_FRAMES		     = 3
MCI_FORMAT_SMPTE_24		     = 4
MCI_FORMAT_SMPTE_25		     = 5
MCI_FORMAT_SMPTE_30		     = 6
MCI_FORMAT_SMPTE_30DROP 	     = 7
MCI_FORMAT_BYTES		     = 8
MCI_FORMAT_SAMPLES		     = 9
MCI_FORMAT_TMSF 		     = 10
MCI_NOTIFY_SUCCESSFUL		     = 1h
MCI_NOTIFY_SUPERSEDED		     = 2h
MCI_NOTIFY_ABORTED		     = 4h
MCI_NOTIFY_FAILURE		     = 8h
MCI_NOTIFY			     = 1h
MCI_WAIT			     = 2h
MCI_FROM			     = 4h
MCI_TO				     = 8h
MCI_TRACK			     = 10h
MCI_OPEN_SHAREABLE		     = 100h
MCI_OPEN_ELEMENT		     = 200h
MCI_OPEN_ALIAS			     = 400h
MCI_OPEN_ELEMENT_ID		     = 800h
MCI_OPEN_TYPE_ID		     = 1000h
MCI_OPEN_TYPE			     = 2000h
MCI_SEEK_TO_START		     = 100h
MCI_SEEK_TO_END 		     = 200h
MCI_STATUS_ITEM 		     = 100h
MCI_STATUS_START		     = 200h
MCI_STATUS_LENGTH		     = 1h
MCI_STATUS_POSITION		     = 2h
MCI_STATUS_NUMBER_OF_TRACKS	     = 3h
MCI_STATUS_MODE 		     = 4h
MCI_STATUS_MEDIA_PRESENT	     = 5h
MCI_STATUS_TIME_FORMAT		     = 6h
MCI_STATUS_READY		     = 7h
MCI_STATUS_CURRENT_TRACK	     = 8h
MCI_INFO_PRODUCT		     = 100h
MCI_INFO_FILE			     = 200h
MCI_GETDEVCAPS_ITEM		     = 100h
MCI_GETDEVCAPS_CAN_RECORD	     = 1h
MCI_GETDEVCAPS_HAS_AUDIO	     = 2h
MCI_GETDEVCAPS_HAS_VIDEO	     = 3h
MCI_GETDEVCAPS_DEVICE_TYPE	     = 4h
MCI_GETDEVCAPS_USES_FILES	     = 5h
MCI_GETDEVCAPS_COMPOUND_DEVICE	     = 6h
MCI_GETDEVCAPS_CAN_EJECT	     = 7h
MCI_GETDEVCAPS_CAN_PLAY 	     = 8h
MCI_GETDEVCAPS_CAN_SAVE 	     = 9h
MCI_SYSINFO_QUANTITY		     = 100h
MCI_SYSINFO_OPEN		     = 200h
MCI_SYSINFO_NAME		     = 400h
MCI_SYSINFO_INSTALLNAME 	     = 800h
MCI_SET_DOOR_OPEN		     = 100h
MCI_SET_DOOR_CLOSED		     = 200h
MCI_SET_TIME_FORMAT		     = 400h
MCI_SET_AUDIO			     = 800h
MCI_SET_VIDEO			     = 1000h
MCI_SET_ON			     = 2000h
MCI_SET_OFF			     = 4000h
MCI_SET_AUDIO_ALL		     = 4001h
MCI_SET_AUDIO_LEFT		     = 4002h
MCI_SET_AUDIO_RIGHT		     = 4003h
MCI_BREAK_KEY			     = 100h
MCI_BREAK_HWND			     = 200h
MCI_BREAK_OFF			     = 400h
MCI_RECORD_INSERT		     = 100h
MCI_RECORD_OVERWRITE		     = 200h
MCI_SOUND_NAME			     = 100h
MCI_SAVE_FILE			     = 100h
MCI_LOAD_FILE			     = 100h
MCI_VD_MODE_PARK		     = MCI_VD_OFFSET + 1
MCI_VD_MEDIA_CLV		     = MCI_VD_OFFSET + 2
MCI_VD_MEDIA_CAV		     = MCI_VD_OFFSET + 3
MCI_VD_MEDIA_OTHER		     = MCI_VD_OFFSET + 4
MCI_VD_FORMAT_TRACK		     = 4001h
MCI_VD_PLAY_REVERSE		     = 10000h
MCI_VD_PLAY_FAST		     = 20000h
MCI_VD_PLAY_SPEED		     = 40000h
MCI_VD_PLAY_SCAN		     = 80000h
MCI_VD_PLAY_SLOW		     = 100000h
MCI_VD_SEEK_REVERSE		     = 10000h
MCI_VD_STATUS_SPEED		     = 4002h
MCI_VD_STATUS_FORWARD		     = 4003h
MCI_VD_STATUS_MEDIA_TYPE	     = 4004h
MCI_VD_STATUS_SIDE		     = 4005h
MCI_VD_STATUS_DISC_SIZE 	     = 4006h
MCI_VD_GETDEVCAPS_CLV		     = 10000h
MCI_VD_GETDEVCAPS_CAV		     = 20000h
MCI_VD_SPIN_UP			     = 10000h
MCI_VD_SPIN_DOWN		     = 20000h
MCI_VD_GETDEVCAPS_CAN_REVERSE	     = 4002h
MCI_VD_GETDEVCAPS_FAST_RATE	     = 4003h
MCI_VD_GETDEVCAPS_SLOW_RATE	     = 4004h
MCI_VD_GETDEVCAPS_NORMAL_RATE	     = 4005h
MCI_VD_STEP_FRAMES		     = 10000h
MCI_VD_STEP_REVERSE		     = 20000h
MCI_VD_ESCAPE_STRING		     = 100h
MCI_WAVE_PCM			     = MCI_WAVE_OFFSET + 0
MCI_WAVE_MAPPER 		     = MCI_WAVE_OFFSET + 1
MCI_WAVE_OPEN_BUFFER		     = 10000h
MCI_WAVE_SET_FORMATTAG		     = 10000h
MCI_WAVE_SET_CHANNELS		     = 20000h
MCI_WAVE_SET_SAMPLESPERSEC	     = 40000h
MCI_WAVE_SET_AVGBYTESPERSEC	     = 80000h
MCI_WAVE_SET_BLOCKALIGN 	     = 100000h
MCI_WAVE_SET_BITSPERSAMPLE	     = 200000h
MCI_WAVE_INPUT			     = 400000h
MCI_WAVE_OUTPUT 		     = 800000h
MCI_WAVE_STATUS_FORMATTAG	     = 4001h
MCI_WAVE_STATUS_CHANNELS	     = 4002h
MCI_WAVE_STATUS_SAMPLESPERSEC	     = 4003h
MCI_WAVE_STATUS_AVGBYTESPERSEC	     = 4004h
MCI_WAVE_STATUS_BLOCKALIGN	     = 4005h
MCI_WAVE_STATUS_BITSPERSAMPLE	     = 4006h
MCI_WAVE_STATUS_LEVEL		     = 4007h
MCI_WAVE_SET_ANYINPUT		     = 4000000h
MCI_WAVE_SET_ANYOUTPUT		     = 8000000h
MCI_WAVE_GETDEVCAPS_INPUTS	     = 4001h
MCI_WAVE_GETDEVCAPS_OUTPUTS	     = 4002h
MCI_SEQ_DIV_PPQN		     = 0 + MCI_SEQ_OFFSET
MCI_SEQ_DIV_SMPTE_24		     = 1 + MCI_SEQ_OFFSET
MCI_SEQ_DIV_SMPTE_25		     = 2 + MCI_SEQ_OFFSET
MCI_SEQ_DIV_SMPTE_30DROP	     = 3 + MCI_SEQ_OFFSET
MCI_SEQ_DIV_SMPTE_30		     = 4 + MCI_SEQ_OFFSET
MCI_SEQ_FORMAT_SONGPTR		     = 4001h
MCI_SEQ_FILE			     = 4002h
MCI_SEQ_MIDI			     = 4003h
MCI_SEQ_SMPTE			     = 4004h
MCI_SEQ_NONE			     = 65533
MCI_SEQ_MAPPER			     = 65535
MCI_SEQ_STATUS_TEMPO		     = 4002h
MCI_SEQ_STATUS_PORT		     = 4003h
MCI_SEQ_STATUS_SLAVE		     = 4007h
MCI_SEQ_STATUS_MASTER		     = 4008h
MCI_SEQ_STATUS_OFFSET		     = 4009h
MCI_SEQ_STATUS_DIVTYPE		     = 400Ah
MCI_SEQ_SET_TEMPO		     = 10000h
MCI_SEQ_SET_PORT		     = 20000h
MCI_SEQ_SET_SLAVE		     = 40000h
MCI_SEQ_SET_MASTER		     = 80000h
MCI_SEQ_SET_OFFSET		     = 1000000h
MCI_ANIM_OPEN_WS		     = 10000h
MCI_ANIM_OPEN_PARENT		     = 20000h
MCI_ANIM_OPEN_NOSTATIC		     = 40000h
MCI_ANIM_PLAY_SPEED		     = 10000h
MCI_ANIM_PLAY_REVERSE		     = 20000h
MCI_ANIM_PLAY_FAST		     = 40000h
MCI_ANIM_PLAY_SLOW		     = 80000h
MCI_ANIM_PLAY_SCAN		     = 100000h
MCI_ANIM_STEP_REVERSE		     = 10000h
MCI_ANIM_STEP_FRAMES		     = 20000h
MCI_ANIM_STATUS_SPEED		     = 4001h
MCI_ANIM_STATUS_FORWARD 	     = 4002h
MCI_ANIM_STATUS_HWND		     = 4003h
MCI_ANIM_STATUS_HPAL		     = 4004h
MCI_ANIM_STATUS_STRETCH 	     = 4005h
MCI_ANIM_INFO_TEXT		     = 10000h
MCI_ANIM_GETDEVCAPS_CAN_REVERSE      = 4001h
MCI_ANIM_GETDEVCAPS_FAST_RATE	     = 4002h
MCI_ANIM_GETDEVCAPS_SLOW_RATE	     = 4003h
MCI_ANIM_GETDEVCAPS_NORMAL_RATE      = 4004h
MCI_ANIM_GETDEVCAPS_PALETTES	     = 4006h
MCI_ANIM_GETDEVCAPS_CAN_STRETCH      = 4007h
MCI_ANIM_GETDEVCAPS_MAX_WINDOWS      = 4008h
MCI_ANIM_REALIZE_NORM		     = 10000h
MCI_ANIM_REALIZE_BKGD		     = 20000h
MCI_ANIM_WINDOW_HWND		     = 10000h
MCI_ANIM_WINDOW_STATE		     = 40000h
MCI_ANIM_WINDOW_TEXT		     = 80000h
MCI_ANIM_WINDOW_ENABLE_STRETCH	     = 100000h
MCI_ANIM_WINDOW_DISABLE_STRETCH      = 200000h
MCI_ANIM_WINDOW_DEFAULT 	     = 0h
MCI_ANIM_RECT			     = 10000h
MCI_ANIM_PUT_SOURCE		     = 20000h
MCI_ANIM_PUT_DESTINATION	     = 40000h
MCI_ANIM_WHERE_SOURCE		     = 20000h
MCI_ANIM_WHERE_DESTINATION	     = 40000h
MCI_ANIM_UPDATE_HDC		     = 20000h
MCI_OVLY_OPEN_WS		     = 10000h
MCI_OVLY_OPEN_PARENT		     = 20000h
MCI_OVLY_STATUS_HWND		     = 4001h
MCI_OVLY_STATUS_STRETCH 	     = 4002h
MCI_OVLY_INFO_TEXT		     = 10000h
MCI_OVLY_GETDEVCAPS_CAN_STRETCH      = 4001h
MCI_OVLY_GETDEVCAPS_CAN_FREEZE	     = 4002h
MCI_OVLY_GETDEVCAPS_MAX_WINDOWS      = 4003h
MCI_OVLY_WINDOW_HWND		     = 10000h
MCI_OVLY_WINDOW_STATE		     = 40000h
MCI_OVLY_WINDOW_TEXT		     = 80000h
MCI_OVLY_WINDOW_ENABLE_STRETCH	     = 100000h
MCI_OVLY_WINDOW_DISABLE_STRETCH      = 200000h
MCI_OVLY_WINDOW_DEFAULT 	     = 0h
MCI_OVLY_RECT			     = 10000h
MCI_OVLY_PUT_SOURCE		     = 20000h
MCI_OVLY_PUT_DESTINATION	     = 40000h
MCI_OVLY_PUT_FRAME		     = 80000h
MCI_OVLY_PUT_VIDEO		     = 100000h
MCI_OVLY_WHERE_SOURCE		     = 20000h
MCI_OVLY_WHERE_DESTINATION	     = 40000h
MCI_OVLY_WHERE_FRAME		     = 80000h
MCI_OVLY_WHERE_VIDEO		     = 100000h

MM_DRVM_OPEN		= 3D0h
MM_DRVM_CLOSE		= 3D1h
MM_DRVM_DATA		= 3D2h
MM_DRVM_ERROR		= 3D3h
MM_STREAM_OPEN		= 3D4h
MM_STREAM_CLOSE 	= 3D5h
MM_STREAM_DONE		= 3D6h
MM_STREAM_ERROR 	= 3D7h
MM_MIXM_LINE_CHANGE	= 3D0h
MM_MIXM_CONTROL_CHANGE	= 3D1h
MMSYSERR_BADDB		= (MMSYSERR_BASE + 14)
MMSYSERR_KEYNOTFOUND	= (MMSYSERR_BASE + 15)
MMSYSERR_READERROR	= (MMSYSERR_BASE + 16)
MMSYSERR_WRITEERROR	= (MMSYSERR_BASE + 17)
MMSYSERR_DELETEERROR	= (MMSYSERR_BASE + 18)
MMSYSERR_VALNOTFOUND	= (MMSYSERR_BASE + 19)
MMSYSERR_NODRIVERCB	= (MMSYSERR_BASE + 20)
CALLBACK_THREAD 		= (CALLBACK_TASK)
CALLBACK_EVENT		= 50000h
WAVECAPS_SAMPLEACCURATE = 20h
WAVECAPS_DIRECTSOUND	= 40h
MIDIERR_BADOPENMODE	= (MIDIERR_BASE + 6)
MIDIERR_DONT_CONTINUE	= (MIDIERR_BASE + 7)
MIDIPATCHSIZE		= 128
MEVT_SHORTMSG		= 0
MEVT_TEMPO			= 1
MEVT_NOP			= 2
MEVT_LONGMSG		= 80h
MEVT_COMMENT		= 82h
MEVT_VERSION		= 84h
MMIOERR_PATHNOTFOUND	= (MMIOERR_BASE + 11)
MMIOERR_ACCESSDENIED	= (MMIOERR_BASE + 12)
MMIOERR_SHARINGVIOLATION = (MMIOERR_BASE + 13)
MMIOERR_NETWORKERROR	= (MMIOERR_BASE + 14)
MMIOERR_TOOMANYOPENFILES = (MMIOERR_BASE + 15)
MMIOERR_INVALIDFILE	= (MMIOERR_BASE + 16)
CFSEPCHAR			equ '+'
MCIERR_NO_IDENTITY	= (MCIERR_BASE + 94)
MCI_INFO_MEDIA_UPC	= 400h
MCI_INFO_MEDIA_IDENTITY = 800h
MCI_INFO_NAME		= 1000h
MCI_INFO_COPYRIGHT	= 2000h
MCI_CDA_STATUS_TYPE_TRACK = 4001h
MCI_CDA_TRACK_AUDIO	= (MCI_CD_OFFSET + 0)
MCI_CDA_TRACK_OTHER	= (MCI_CD_OFFSET + 1)
MCI_SEQ_STATUS_NAME	= 400Bh
MCI_SEQ_STATUS_COPYRIGHT = 400Ch

WAVE_FORMAT_QUERY		     = 1h
WAVE_MAPPED			     = 4h
WAVE_FORMAT_DIRECT		     = 8h
WAVE_FORMAT_DIRECT_QUERY	     = WAVE_FORMAT_QUERY OR WAVE_FORMAT_DIRECT
WAVE_FORMAT_1M08		     = 1h
WAVE_FORMAT_1S08		     = 2h
WAVE_FORMAT_1M16		     = 4h
WAVE_FORMAT_1S16		     = 8h
WAVE_FORMAT_2M08		     = 10h
WAVE_FORMAT_2S08		     = 20h
WAVE_FORMAT_2M16		     = 40h
WAVE_FORMAT_2S16		     = 80h
WAVE_FORMAT_4M08		     = 100h
WAVE_FORMAT_4S08		     = 200h
WAVE_FORMAT_4M16		     = 400h
WAVE_FORMAT_4S16		     = 800h
WAVE_FORMAT_PCM 		     = 1

MM_WOM_OPEN			     = 3BBh
MM_WOM_CLOSE			     = 3BCh
MM_WOM_DONE			     = 3BDh
MM_WIM_OPEN			     = 3BEh
MM_WIM_CLOSE			     = 3BFh
MM_WIM_DATA			     = 3C0h
MM_MIM_OPEN			     = 3C1h
MM_MIM_CLOSE			     = 3C2h
MM_MIM_DATA			     = 3C3h
MM_MIM_LONGDATA 		     = 3C4h
MM_MIM_ERROR			     = 3C5h
MM_MIM_LONGERROR		     = 3C6h
MM_MOM_OPEN			     = 3C7h
MM_MOM_CLOSE			     = 3C8h
MM_MOM_DONE			     = 3C9h

WOM_OPEN			     = MM_WOM_OPEN
WOM_CLOSE			     = MM_WOM_CLOSE
WOM_DONE			     = MM_WOM_DONE
WIM_OPEN			     = MM_WIM_OPEN
WIM_CLOSE			     = MM_WIM_CLOSE
WIM_DATA			     = MM_WIM_DATA

WHDR_DONE                            = 1h
WHDR_PREPARED                        = 2h
WHDR_BEGINLOOP                       = 4h
WHDR_ENDLOOP                         = 8h
WHDR_INQUEUE                         = 10h
WHDR_VALID                           = 1Fh
